//+------------------------------------------------------------------+
//|                                                    Spdmtr_v4.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Blue
#property indicator_color2 DodgerBlue
#property indicator_color3 Red
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
extern int MA_Period1=2;
extern int MA_Period2=8;
extern bool showSpeedMeter=true;
extern bool limit=true;
extern int limitValue=5;
//---- buffers
double SpeedMeter[];
double SMA1[];
double SMA2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(3);
   if(showSpeedMeter){
      SetIndexStyle(0,DRAW_LINE);
   }else{
      SetIndexStyle(0,DRAW_NONE);   
   }
   SetIndexBuffer(0,SpeedMeter);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,SMA1);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,SMA2);
   IndicatorShortName("SpeedMeter("+MA_Period1+","+MA_Period2+")");
   SetIndexLabel(0,"SpeedMeter");
   SetIndexLabel(1,"SMA"+MA_Period1);
   SetIndexLabel(1,"SMA"+MA_Period2);
   return(0);
  }
//+------------------------------------------------------------------+
//| Average True Range                                               |
//+------------------------------------------------------------------+
int start()
  {
   int i,j,counted_bars=IndicatorCounted();
   double sum;
//----
   if (counted_bars<0) return(-1);
   if (counted_bars>0) counted_bars--;
   i=Bars-counted_bars-1;
   while(i>=0)
     {
      if(i==Bars-2){
         SpeedMeter[i]=0;
      }
      if(Close[i]>Open[i]){
         SpeedMeter[i]=SpeedMeter[i+1]+1;
      }else if(Close[i]<Open[i]){
         SpeedMeter[i]=SpeedMeter[i+1]-1;
      }else{
         SpeedMeter[i]=SpeedMeter[i+1]+0;
      }
      if(limit){
         if(SpeedMeter[i]>limitValue){
            SpeedMeter[i]=limitValue;
         }
         if(SpeedMeter[i]<-limitValue){
            SpeedMeter[i]=-limitValue;
         }
      }
      if(i<=Bars-1-MA_Period1){
         sum=0;
         for(j=0;j<MA_Period1;j++){
            sum+=SpeedMeter[i+j];
         }
         SMA1[i]=sum/MA_Period1;
      }
      if(i<=Bars-1-MA_Period2){
         sum=0;
         for(j=0;j<MA_Period2;j++){
            sum+=SpeedMeter[i+j];
         }
         SMA2[i]=sum/MA_Period2;
      }
      i--;
    }
//----
   return(0);
  }
//+------------------------------------------------------------------+